package de.oaa.xxx.aufgaben.controller;

import de.oaa.xxx.aufgaben.Sperre;
import de.oaa.xxx.aufgaben.entity.AufgabenGruppeEntity;
import de.oaa.xxx.aufgaben.entity.SperreEntity;
import de.oaa.xxx.aufgaben.repository.AufgabenGruppeRepository;
import de.oaa.xxx.aufgaben.repository.SperreRepository;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.http.ResponseEntity;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.web.bind.annotation.DeleteMapping;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;
import org.springframework.web.servlet.support.ServletUriComponentsBuilder;

import java.util.UUID;

@RestController("aufgabenSperreController")
@RequestMapping("/sperre")
@Transactional
public class SperreController {

    private static final Logger LOGGER = LoggerFactory.getLogger(SperreController.class);

    private final SperreRepository sperreRepository;
    private final AufgabenGruppeRepository gruppeRepository;

    public SperreController(SperreRepository sperreRepository, AufgabenGruppeRepository gruppeRepository) {
        this.sperreRepository = sperreRepository;
        this.gruppeRepository = gruppeRepository;
    }

    @GetMapping("/{sperreId}")
    public ResponseEntity<Sperre> get(@PathVariable UUID sperreId) {
        return sperreRepository.findById(sperreId)
                .map(entity -> ResponseEntity.ok(entity.toSperre()))
                .orElse(ResponseEntity.noContent().build());
    }

    @PostMapping
    public ResponseEntity<Void> create(@RequestBody Sperre sperre) {
        if (sperre.getKurzText() == null || sperre.getText() == null || sperre.getMinutenVon() == null
                || sperre.getGruppeId() == null || sperre.getSperreFuer() == null || sperre.getSperreFuer().isEmpty()) {
            return ResponseEntity.badRequest().build();
        }
        AufgabenGruppeEntity gruppeEntity = gruppeRepository.findById(sperre.getGruppeId()).orElse(null);
        if (gruppeEntity == null || gruppeEntity.getAufgaben().size() > 50) {
            return ResponseEntity.badRequest().build();
        }
        SperreEntity entity = SperreEntity.create(sperre, gruppeEntity);
        sperreRepository.save(entity);
        return ResponseEntity.created(
                ServletUriComponentsBuilder.fromCurrentRequest().path("/{id}").buildAndExpand(entity.getSperreId()).toUri()
        ).build();
    }

    @DeleteMapping
    public ResponseEntity<Void> delete(@RequestBody Sperre sperre) {
        try {
            sperreRepository.findById(sperre.getSperreId()).ifPresent(sperreRepository::delete);
            return ResponseEntity.accepted().build();
        } catch (Exception exception) {
            LOGGER.error(exception.getMessage(), exception);
            return ResponseEntity.internalServerError().build();
        }
    }
}
